
;+ ***********************************************************************
; NAME:
;	NEWLEC1D
;
; PURPOSE:
;	Cette procedure lit les images contenues dans un fichier NRH 1 
;	dimension au format HELIO ou FITS
;
; CATEGORY:
;	NRH1 fichier
;
; CALLING SEQUENCE:
;	 NEWLEC1D, Unit, Images, Str
;
; INPUTS:
;	UNIT	unite de lecture. Comme pour LEC1D, le nom du fichier
;		est donne dans COMMON NRH1_GLOBAL Nomfich(Unit)
;	
; KEYWORD PARAMETERS:
;	FICHIER	nom du fichier a lire
;
;	OLDMODE	a voir
;
; OUTPUTS:
;	IMAGES Tableau contenant les images (voir LEC1D pour le format)
;
;	STR	Structure liee au images lues (voir NRH1_STR_IMAGES__DEFINE
;
; COMMON BLOCKS:
;	NRH1_GLOBAL
;	NRH1_HELIO
;
; PROCEDURE:
;	Cette procedure appelle LEC1D qui lit les fichiers au format HELIO
;	ou qui appelle LEC_NRH1 pour lire les fichiers 1D FITS (extension fts)
;
; MODIFICATION HISTORY: Contact: (bonmartin@obspm.fr)
;	12/11/98	adapte du logiciel XHELIO (JB)
;	15/01/99	nom de fichier memorise dans mainstruc.ewfile dans
;			tous les cas
;-*******************************************************************

FUNCTION newlec1d,lun,x,stx,FICHIER=fichier,OLDMODE=oldmode

Common NRH1_GLOBAL,nomfich,fichinfo
Common NRH1_HELIO,mainstruct

WIDGET_CONTROL,/HOURGLASS
if not keyword_set(fichier) THEN $
fichier = nomfich(lun)

chemin=!chemin
pos=STRPOS(fichier,']')

IF ( pos NE -1) THEN BEGIN
  !chemin = STRMID(fichier,0,pos+1)
  fichier = STRMID(fichier,pos+1,100)
ENDIF

	SZ= SIZE(FINDFILE(!chemin+fichier))
IF SZ(0) EQ 0 THEN BEGIN
   !chemin=chemin
   R=WIDGET_MESSAGE('File '+!chemin+fichier+' not found')
   RETURN,1
ENDIF

IF keyword_set(oldmode) THEN BEGIN   ; on ne le mets pas en memoire
   lec1d,lun,x,stx,FICHIER=fichier, ARRAY = mainstruct.array
ENDIF ELSE BEGIN
;    x = FILELOAD(fichier)
;    IF N_elements(x) EQ 1 THEN BEGIN
         lec1d,lun,x,stx,FICHIER=fichier, ARRAY = mainstruct.array
;         ret=NRH1_FILESTORE(x,fichier)
;    ENDIF ELSE BEGIN
;       err = newlitentete(lun,fichier,file)
;       IF err EQ 1 THEN RETURN,err
;      fichinfo(lun)=file
;      nomfich(lun)=fichier
;   ENDELSE
ENDELSE

   		mainstruct.ewfile=fichier

IF (pos NE -1) THEN $
!chemin=chemin


RETURN,0
END
