
;+ ***********************************************************************
; NAME:
;	NEWLITENTETE
;
; PURPOSE:
;	Cette procedure gere les fichiers d'images 1D pour la lecture
;	des informations d'entete des fichiers au format HELIO ou FITS
;
; CATEGORY:
;	NRH1 Fichier
;
; CALLING SEQUENCE:
;	Ret = NEWLITENTETE(Unit,Fichier,Info)
;
; INPUTS:
;	UNIT	Unite de lecture
;
;	FICHIER	Nom du fichier	
;
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	INFO	Structure de type NRH1_FILEINFO
;
;	RET	Retour erreur: 0 = OK, 1 = Fichier non trouve
;
; COMMON BLOCKS:
;	NRH1_GLOBAL
;
; PROCEDURE:
;	Cette procedure appelle LITENTETE(fichiers HELIO) et eventuellement 
;	LIT_HEADER_NRH1(Fichiers FITS) pour remplir la structure INFO ainsi
;	que FICHINFO du COMMON NRH1_GLOBAL
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
;	13/11/92  Adapte du logiciel XHELIO (JB)
;	15/01/99  test sur l'existence d'un fichier remplace par test sur
;		  fichier = '' pour le retour erreur (JB)
;-*******************************************************************

FUNCTION newlitentete,lun,fichier,fichierinfo

Common NRH1_GLOBAL,nomfich,fichinfo

chemin=!chemin
pos=STRPOS(fichier,']')

IF ( pos NE -1) THEN BEGIN
  !chemin = STRMID(fichier,0,pos+1)
  fichier = STRMID(fichier,pos+1,100)
ENDIF

IF Fichier EQ '' THEN BEGIN
   !chemin=chemin
   RETURN,1
ENDIF
WIDGET_CONTROL,/HOURGLASS

   
trouve=0
FOR i=0,9 DO BEGIN
   IF (fichinfo(i).nomfich EQ (!chemin+STRUPCASE(fichier)+';')) THEN BEGIN
      trouve=1
      fichierinfo=fichinfo(i)
   ENDIF
ENDFOR

IF (trouve EQ 0) THEN BEGIN
   litentete,lun,fichier,fichierinfo
   fichinfo(lun)=fichierinfo
   nomfich(lun)=fichier
   close,lun
ENDIF

IF (pos NE -1) THEN $
!chemin = chemin

RETURN,0
END
