
;+ ***********************************************************************
; NAME:
;	MENUMANUPOS
;
; PURPOSE:
;	Cette procedure contient les WIDGETS de gestion des donnees pour 
;	le trace des positions 2D du NRH a partir de donnees entrees 
;	manuellement.
;
; CATEGORY:
;	NRH1 Menu
;
; CALLING SEQUENCE:
;	MENUMANUPOS
;
; INPUTS:
;	Non
;
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	Non
;
; COMMON BLOCKS:
;	Non
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)
;	03/12/98 adapte du logiciel XHELIO
;***************************************************************************
pro MENUMANUPOS_EVENT, ev


common manupos

stash = WIDGET_INFO ( ev.top, /CHILD )
WIDGET_CONTROL, stash, GET_UVALUE = state

IF ev.id EQ state.base_list THEN BEGIN
; ev.index est le numero de la ligne contenant les donnees cherchees
	state.linenumber = ev.index
ENDIF

IF ev.id EQ state.base_done THEN BEGIN
	data= ' '
	openr,1, 'manpos_nrh.dat'
	FOR i = 0, state.linenumber DO readf, 1, data
	close, 1
	read_manpos, data, idate, heurms, frequence, canew, fwhmew, cansn, $
		fwhmsn
	WIDGET_CONTROL, ev.top, /DESTROY
	RETURN
ENDIF
; on sauve les modifications
WIDGET_CONTROL, stash, SET_UVALUE = state

END


pro MENUMANUPOS

common manupos

base = WIDGET_BASE($
	TITLE='Computation of heliographic positions', $
	/FRAME, /COLUMN)
base_label = WIDGET_LABEL(base, VALUE = 'Select a set of input values:')

linenumber = 0
a= ' '
openr,1, 'manpos_nrh.dat', ERROR=err
IF err NE 0 THEN RETURN

icont=0
strdata = STRARR(1000)
while not eof(1) do begin
	readf,1,a
	strdata(icont) = a
	icont=icont+1
endwhile
close, 1
strdata = strdata(0:icont-1)

num = 10
IF icont LT num THEN num=icont
base_list = WIDGET_LIST(base, VALUE = strdata, YSIZE=num)
base_done = WIDGET_BUTTON(base, VALUE = 'Done', XSIZE = 6)

state = {base:base, base_list:base_list, base_done:base_done, $
	linenumber:linenumber}

WIDGET_CONTROL, WIDGET_INFO ( base, /CHILD ), SET_UVALUE = state 

WIDGET_CONTROL, base, /REALIZE
XMANAGER, 'MENUMANUPOS', base
;stash = WIDGET_INFO ( base, /CHILD )
;WIDGET_CONTROL, stash, GET_UVALUE = state

END
