
;+ ***********************************************************************
; NAME:
;	INIT_NRH_CFILE
;
; PURPOSE:
;	Initialisation correspondant a une extension d'une CFILE de NRH
;
; CATEGORY:
;	Fichier CFILE.
;
; CALLING SEQUENCE:
;	INIT_NRH_CFILE, File, Extend, Str_inf, Str_lim
;
; INPUTS:
;	FILE	Nom du fichier
;	EXTEND	Numero de l'extension
;
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	STR_INF	Structure de type NRH_STR_INFIC
;	STR_LIM	Structure de type NRH_STR_LIM
;
; COMMON BLOCKS:
;	Non
;
; SIDE EFFECTS:
;	Describe "side effects" here.  There aren't any?  Well, just delete
;	this entry.
;
; PROCEDURE:
;	La procedure remplit les structures en fonction des informations 
;	contenues dans le HEADER d'extension, sauf les limites de temps qui
;	sont remplies par OPEN_NRH_CFILE
;
; EXAMPLE:
;	Please provide a simple example here
;
; MODIFICATION HISTORY:
;	Ecrit par:J Bonmartin (obspm.fr) le 15/09/98
;-*******************************************************************

PRO INIT_NRH_CFILE, File, Extend, Str_inf, Str_lim

	HEADER = HEADFITS( File, EXTEN= Extend)


		Str_inf.Xcen = FXPAR( Header, 'CRPIX1')
		Str_inf.Ycen = FXPAR( Header, 'CRPIX2')
		Str_inf.Ray = FXPAR( Header, 'SOLAR_R')
		Str_inf.Freq = FXPAR(Header, 'FREQ')
		Str_inf.Hd = FXPAR(Header, 'TIM_STR')
		Str_inf.Hf = Fxpar(Header, 'TIM_END')
		Str_inf.Physpar = 0
		IF STRCOMPRESS(FXPAR(Header, 'PHYSPARA'),/REMOVE_ALL) EQ $
			'STOKESV' THEN Str_inf.Physpar = 1


		Str_lim.xd = FXPAR( Header, 'XLIML')
		Str_lim.xf = FXPAR( Header, 'XLIMH')
		Str_lim.yd = FXPAR( Header, 'YLIML')
		Str_lim.yf = FXPAR( Header, 'YLIMH')

END