
;+ ***********************************************************************
; NAME:
;	FOPEN_YOHKOH
;
; PURPOSE:
;	Lecture des donnees YOHKOH au format FITS
;
; CATEGORY:
;	Input, Output
;
; CALLING SEQUENCE:
;	 FOPEN_YOHKOH,File, Str_inf2d

;
; INPUTS:
;	File	chemin et nom du fichier a lire
;
; KEYWORD PARAMETERS:
;
; OUTPUTS:
;	Str_inf2d	structure d'information de fichier (NRH_STR_INF2D)
;

; PROCEDURE:
;	Cette procedure lit le contenu du Header d' un fichier FITS YOHKOH
; Les mots cles CRPIX1, CRPIX2, RADIUS doivent exister
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin (obspm.fr)le 24/11/9709/09/98
;-*******************************************************************

PRO FOPEN_YOHKOH,File, Str_inf2d

	H = HEADFITS( File)


		Str_inf2d.date= FXPAR(h,'DATE-OBS')
		Str_inf2d.Freq = 0.0

		str_inf2d.INSTRUME = ''
		Str_inf2d.CONTENT = 'STD'
		str_inf2d.nim = 1
		Str_inf2d.hd = FXPAR(h, 'TIME-OBS')
		Str_inf2d.hf = Str_inf2d.hd
		Str_inf2d.npx = FXPAR (h, 'NAXIS1')
		Str_inf2d.npy = FXPAR (h,'NAXIS2')

	  	Str_inf2d.Tscan = Fxpar(h, 'EXPTIME')



        	Str_inf2d.Xcen = FXPAR(h,'CRPIX1')
		if !err lt 0 THEN BEGIN
			IMAGE = MRDFITS(File)
			Optic_circ, IMAGE, Xcen, Ycen, Ray
			STR_Inf2d.Xcen=Xcen&Str_inf2d.Ycen=Ycen
			Str_inf2d.ray=ray
			RETURN & END
        	Str_inf2d.Ycen = FXPAR(h,'CRPIX2')
		if !err lt 0 THEN BEGIN
			IMAGE = MRDFITS(File)
			Optic_circ, IMAGE, Xcen, Ycen, Ray
			STR_Inf2d.Xcen=Xcen&Str_inf2d.Ycen=Ycen
			Str_inf2d.ray=ray
			RETURN & END
        	Str_inf2d.RAY = FXPAR(h,'RADIUS')
		if !err lt 0 THEN BEGIN
			IMAGE = MRDFITS(File)
			Optic_circ, IMAGE, Xcen, Ycen, Ray
			STR_Inf2d.Xcen=Xcen&Str_inf2d.Ycen=Ycen
			Str_inf2d.ray=ray
			RETURN & END
end