
;+ ***********************************************************************
; NAME:
;	NRH_WR_POINT
;
; PURPOSE:
;	Cette procedure ecrit dans un fichier les informations correspondant
;	a un releve de point
;
; CATEGORY:
;	Fichier 
;
; CALLING SEQUENCE:
;	NRH_WR_POINT, Unit, Point

;
; INPUTS:
;	UNIT	Unite logique correspondant au fichier de coordonnees
;
;	POINT	Stucture contenant les informations (NRH_STR_COORD__DEFINE)
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	Ecriture dns le fichier
;
; COMMON BLOCKS:
;	Non
;
; RESTRICTIONS:
;	Les informations sont ecrites dans le fichier sous forme d'une
;	chaine de cracteres. 
;	La structure NRH_STR_COORD peut etre remplie a partir du contenu
;	d'une ligne lue par RD_POINT
;
; PROCEDURE:
;	
;
; EXAMPLE:
;	Please provide a simple example here
;
; MODIFICATION HISTORY:
;	Ecrit par: j Bonmartin (obspm.fr) le 07/09/98
;-*******************************************************************


PRO NRH_WR_POINT, Unit, Point

LIGNE = '                                                             '

	STRPUT, Ligne, Point.instrume
		Position = 8
	STRPUT, Ligne, Point.date, Position
		Position = Position + 11
	STRPUT, Ligne, Point.time, Position
		Position = Position + 13
	STRPUT, Ligne, STRING(Point.Freq, FORMAT='(F5.1)'), Position
		Position = Position + 7
		Text = STRING(Point.Xcoord, FORMAT='(F5.2)')
	STRPUT, Ligne, text, Position
		Position = Position + 6
		Text = STRING(Point.Ycoord, FORMAT='(F5.2)')
	STRPUT, Ligne, text, Position
		Position = Position + 6
		Text = STRING(FLOAT(Point.Inten), FORMAT='(E10.2)')
	STRPUT, Ligne, text, Position

Printf, Unit, Ligne

END


