
;+ ***********************************************************************
; NAME:
;	READ_FLUX
;
; PURPOSE:
;	Cette procedure traite les fichiers de FLUX ou assimiles du NRH
;	Elle permet de selecter un fichier de flux et dans le fichier
;	une ligne de FLUX.
;
; CATEGORY:
;	Fichiers NRH
;
; CALLING SEQUENCE:
;	READ_FLUX, Flux, Time, [Header]
;
; INPUTS:
;	Non
;	
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	FLUX	Tableau du flux lu
;
;	TIME	Tableau de temps correspondant en ms
;
; OPTIONAL OUTPUTS:
;	HEADER	Header correspondant au flux lu
;
; COMMON BLOCKS;
;	Non
;
; PROCEDURE:
;	Cette procedure utilise DIALOG_PICKFILE pour selectionner le fichier
;	et CW_XTD_NRH pour selectionner la ligne
;
; EXAMPLE:
;	READ_FLUX, Flux,Time
;
; MODIFICATION HISTORY:
;	Ecrit par: J Bonmartin (obspm.fr) le 11/09/98
;-*******************************************************************

PRO READ_FLUX, Flux, Time, Header

	File = DIALOG_PICKFILE( Filter = '*f*.fts')

	INDIC = Cw_xtd_nrhf ( File)

	Tab = MRDFITS( File, Indic, Header, /SILENT)

FLUX = Tab.flux
TIME = Tab.time

END
