
;+ ***********************************************************************
; NAME:
;	CREATE_NRH_PFILE
;
; PURPOSE:
;	Cette procedure cree un fichier vide de type PFILE (positons) de NRH
;
; CATEGORY:
;	RH_2D, Recherche de position
;
; CALLING SEQUENCE:
;	CREATE_NRH_PFILE, File, Fimg
;
; INPUTS:
;	File:	nom du fichier de positions a creer
;	Fimg:	nom du fichier d'images correspondant
;
; EXAMPLE:
;	Please provide a simple example here
;
; MODIFICATION HISTORY:
;	Ecrit par: C. Reni 2/10/1998
;-*******************************************************************

PRO CREATE_NRH_PFILE, File, Fileimg

	ERRMSg=''
	Hprim = HEADFITS(Fileimg)
	SXADDPAR, Hprim, 'DATE', FORM_DATE()
	SXADDPAR, Hprim, 'FILEIMG', Fileimg
	SXADDPAR, Hprim, 'N_EXTEND', 0
	SXADDPAR, Hprim, 'NRH_DATA', '2DS'
	SXADDPAR, Hprim, 'ORIGIN', 'CW_POS.PRO'
	; on ecrit que le nom, pas le chemin
	nom = STR_SEP(File,'/')
	Sz= Size(nom)
	SXADDPAR, Hprim, 'FILENAME', nom(sz(1)-1),' '
	WRITEFITS, File, 0, Hprim
END
