;+ *************************************************************************************
; NAME:
;	RDFILEPOS
;
; PURPOSE:
;	lit une colonne d'un fichier de positions
;	RH_2D
;
; CATEGORY:
;	RH_2D, recherche de positions
;
; CALLING SEQUENCE:
;	Tab = RDFILEPOS(Fich, Col, Exte)
;	
; INPUTS:
;	Fich:	Nom du fichier rh2d de positions
;	Col:	Colonne a lire (numero ou intule)
;	Exte:	Numero de l'extension
;
; OUTPUTS:
;	Tab:	Colonne lue
;
; EXAMPLE:
;	time = RDFILEPOS('position.fts', 'TIME', 1)
;
; MODIFICATION HISTORY:
;
; 	Written by:	C. Reni, 09/1998
;- *************************************************************************************

FUNCTION RDFILEPOS, fich, col, exte

	FXBOPEN, unit, fich, exte
	FXBREAD, unit, data, col 
	FXBCLOSE, unit
	RETURN, data
END
