PRO rh_tab_correl, date_obs, nb_correl, correl
; parametres d'entree  : date_obs, nb_correl 
;            de sortie : correl
;
; Reconstruction de la table entfi.corel
;  dans le cas ou on lit des donnees avec OPEN_V.PRO  et READ_2V.PRO
    jul_cor = julday (10, 8, 1999)	; pour "julien correction". 8 oct 99
    jul_dat = julday (date_obs(1), date_obs(0), rh_date100(date_obs(2), /full))
					; pour "julien date". 

    type_correl = 2   ; 1 - jusqu'au 7 oct 98 inclus
                      ; 2 - ajout antenne NS45 
                      ; 3 - ajout antennes anti_alias

    if (jul_dat  lt  jul_cor)  then  begin
	type_correl = 1
	print, 'correl : pas d''antennes NS45'
    endif

;    jul_ali = julday (12, 1, 2003)      ; 1 oct 2003
;    if (jul_dat  ge  jul_ali)  then  begin
     if (nb_correl eq 648) then begin
	type_correl = 3
	print, 'correl : avec antennes ANTI_ALIAS'
    endif
    if type_correl eq 2 then print, 'correl : sans antennes ANTI_ALIAS'

    ref_2d = [ 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30,     $
            31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43 ]
           ; Antennes de reference NS (y compris NS45) pour les correlations 
           ; 2D avec EW2, EW1, et le reseau EW
; ---------------------
    ref_45 = [ 43, 43]
           ; correlations NS pures avec NS45 a partir du 8 oct 98

           ; OU BIEN  

    ref_ew0 = [  2,  2]
           ; correlations 2D avec EW0 jusqu'au 7 oct 98 inclus
; ---------------------

    ref_ew =  [  0,  1,  2]
           ; correlations EW pures

    ref_ns = [  27, 19]
           ; correlations NS pures

    ref_a_alias = [ 44, 45, 46, 47]
           ; correlations anti_alias 2D  EWAn avec NS
           ; a partir de dec 2003 (? a definir)

    if type_correl eq 1 then  ref   = [ref_2d,  ref_ew0,  ref_ew,  ref_ns]
    if type_correl eq 2 then  ref   = [ref_2d,   ref_45,  ref_ew,  ref_ns]
    if type_correl eq 3 then  ref   = [ref_2d,   ref_45,  ref_ew,  ref_ns, $
                                                 ref_a_alias]
    nb_barr_tot = n_elements(ref) 
  
    rs_ew  = [ 0,  1,  3,  4,  5,  6,  7,  8,  9, 10, 11,     $
                              12, 13, 14, 15, 16, 17, 18]

    rs_ns1 = [19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29,   $
                              30, 31, 32, 33, 34, 35, 36]

    rs_ns2 = [29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39,   $
                              40, 41, 42, 43, 26, 27, 28]

    correl = intarr(2,18,nb_barr_tot)
    for i=0,17 do correl(0,i,0:nb_barr_tot-1) = ref
; correl 2D 
	;				correlations
	;  NS0  avec E2, E1, H1 a H16	  0 a  17
	;  NS1  ---- ----------------    18 a  35
	;  NS23 ---- ----------------       a 431
	;  NS45	---- ---------------- 	432 a 449

    for i=0,24 do correl(1,*,i)= rs_ew
; correl barrettes 25,26 
	; jusqu'au 7 oct 98 inclus:
	;  E0	avec NS0  a NS17	450 a 467
	;  --   ---- NS10 a NS23	468 a 481
	;  --	---- NS45		482
	;  --	---- NS7  a NS9		483 a 485
	; a partir du 8 oct 98 inclus:
	;  NS45	avec NS0  a NS17	450 a 467
	;  ---- ---- NS10 a NS23	468 a 481
	;  ----	---- NS45               482
	;  ---- ---- NS7  a NS9         483 a 485
   
    correl(1,*,25)= rs_ns1
    correl(1,*,26)= rs_ns2
; correl EW pures
	;  E2	---- E2, E1, H1 a H16	486 a 503
	;  E1	---- E2, E1, H1 a H16	504 a 521
	;  E0	---- E2, E1, H1 a H16	522 a 539

    correl(1,*,27)= rs_ew
    correl(1,*,28)= rs_ew
    correl(1,*,29)= rs_ew
; correl NS pures
	;  NS8	---- NS0  a NS17	540 a 557
	;  NS0	---- NS10 a NS23, NS45	558 a 572
	;  ---	---- NS7 a NS9		573 a 575

    correl(1,*,30)= rs_ns1
    correl(1,*,31)= rs_ns2
; antennes anti_alias
    if type_correl eq 3 then begin
; correl 2D anti-alias
	;  EWA1	---- NS0  a NS17	576 a
        ;  EWA4 ---- NS0  a NS17	    a 647
        correl(1,*,32)= rs_ns1
        correl(1,*,33)= rs_ns1
        correl(1,*,34)= rs_ns1
        correl(1,*,35)= rs_ns1
    endif
    ch_format = '("B:",i2," R:",i2," r:",18i3)' 
;    FOR k=0,nb_barr_tot-1 DO print,k,correl(0,0,k),correl(1,*,k),format=ch_format 
    correl = reform (correl,2,18*nb_barr_tot)
           ; pour revenir aux 2 dimensions du tableau entfi.corel      
;stop
return
end
