
;+ ***********************************************************************
; NAME:
;	CDATE
;
; PURPOSE:
;	Cette fonction remplace le nom du mois sur 3 caracteres, par le 
;	numero du mois
;
; CATEGORY:
;	NRH1 General
;
; CALLING SEQUENCE:
;	Resultat = CDATE( Date )	
;
; INPUTS:
;	DATE	Chaine de caracteres contenant DD-MMM-yyYY
;	
; KEYWORD PARAMETERS:
;	Non
;
; OUTPUTS:
;	Resultat Chaine de caracteres contenant DD/nm/yyYY
;
; COMMON BLOCKS:
;	Non
;
; SIDE EFFECTS:
;	La chaine de caracteres est decodee en fonction de la position des
;	caracteres dans la chaine, donc le separateur peut etre quelconque
;
; EXAMPLE:
;	PRINT, DATE('20/APR/1998')
;
; MODIFICATION HISTORY: (bonmartin@obspm.fr)

;
;-*******************************************************************
FUNCTION CDATE,input

mois=['JAN','FEB','MAR','APR','MAY','JUN','JUL',$
         'AUG','SEP','OCT','NOV','DEC']


strbuff=strmid(input,0,2)+'/' ;jour
i=0
while (mois(i) ne strupcase(strmid(input,3,3))) do i=i+1
i=i+1
strtmp=strmid(string(i),7,1)
if (strtmp le 9) then strbuff=strbuff+'0'
strbuff=strbuff+strtmp+'/'+strmid(input,7,4)   ;mois+annee

return,strbuff

END