function mil_time, msecs

;+
; NAME:
;        mil_time
; PURPOSE:
;	 calculates civil time in hours, minutes, seconds, and
;	 milliseconds from time in milliseconds
; CATEGORY:
;        ???
; CALLING SEQUENCE:
;        result = mil_time(msecs) 
; INPUTS:
;	 msecs = any type except string and complex; contains time in
;	 milliseconds of day.
; OPTIONAL (KEYWORD) INPUT PARAMETERS:
;	 None.
; OUTPUTS:
;        Function result = intarr(4) containing hours, minutes, seconds,
;	 milliseconds.
; COMMON BLOCKS:
;        None.
; SIDE EFFECTS:
;	 None.
; RESTRICTIONS:
;	 None.
; MODIFICATION HISTORY:
;	Created from mil_civtime below, J Bonmartin 12/08/98 (obspm.fr)
;        AM, Sep, 1990.
;-

 hour = fix(msecs/3.6d06)
 rsec = msecs-hour*3.6d06
 min  = fix(rsec/6.d04)
 rsec = rsec-min*6.d04
 sec  = fix(rsec/1.d03)
 msec = fix(rsec-sec*1.d3)

 return, [hour,min,sec,msec]

 end
