
;+ ***********************************************************************
; NAME:
;	NRH_IDFREQ
;
; PURPOSE:
;	Cette fonction donne l'indice d'une frequence dans le tableau
;	des flux
;
; CATEGORY:
;	NRH Routines
;
; CALLING SEQUENCE:
;	Indice = NRHR_IDFREQ( 'Frequence', 'Fichier')
;
; INPUTS:
;	FREQUENCE nom de la frequence
;	FICHIER	  nom du fichier
;	
; KEYWORD PARAMETERS:
;	REPERT	repertoire contenant le fichier(Defaut fichier courant)
;
; OUTPUTS:
;	
;
; OPTIONAL OUTPUTS:
;	
; COMMON BLOCKS:
;	
;
; SIDE EFFECTS:
;
; RESTRICTIONS:
;
; PROCEDURE:
;
; EXAMPLE:
;
; MODIFICATION HISTORY:
;	Ecrit par:J Bonmartin(bonmartin@obspm.fr) le 10/10/00
;-*******************************************************************

FUNCTION NRHR_IDFREQ, Freq, File, REPERT= Rep

IF NOT KEYWORD_SET (REPERT) THEN CD, CURRENT= Rep
HD = HEADFITS(Rep+File)

IND=0

REPEAT BEGIN
	NFreq = 'FREQ'+STRCOMPRESS(String(IND),/REMOVE_ALL)
	IND= IND+1
END UNTIL (FXPAR(Hd, Nfreq) EQ FREQ OR IND GT FXPAR(HD, 'NFREQ'))



IF IND GT FXPAR(HD, 'NFREQ') THEN BEGIN
   r=DIALOG_MESSAGE('Frequency '+STRCOMPRESS(string(Freq))+' not used')
	IND=0
ENDIF

RETURN,IND-1

END

